#include <krb5.h>
#include "pam_krb5.h"

const char *
compat_princ_component(krb5_context context, krb5_principal princ, int n)
{
	return princ->name.name_string.val[n];
}

int
compat_is_new_password_prompt(krb5_prompt_type *pt, krb5_prompt *prompts,
    int i)
{
    return prompts[i].type == KRB5_PROMPT_TYPE_NEW_PASSWORD;
}

krb5_error_code
compat_new_memory_cache(krb5_context context, krb5_ccache *ccache)
{

	return krb5_cc_gen_new(context, &krb5_mcc_ops, ccache);
}

/* Heimdal's krb5_cc_gen_new always uses mkstemp, providing its own
 * implementation if the target system doesn't have one.
 */
krb5_error_code
compat_new_file_cache(krb5_context context, krb5_ccache *ccache)
{
	return krb5_cc_gen_new(context, &krb5_fcc_ops, ccache);
}

krb5_prompt_type *
krb5_get_prompt_types(krb5_context context)
{
    return NULL;
}

void
krb5_free_data_contents(krb5_context context, krb5_data *data)
{
	krb5_xfree(data->data);
}

#ifndef HAVE_KRB5_STRING_TO_DELTAT
/* Heimdal versions previous to 0.3f do not have krb5_string_to_deltat */
krb5_error_code
krb5_string_to_deltat(char *s, krb5_deltat *t)
{
	int	tmp;

	tmp = parse_time(s, "s");
	if (tmp >= 0) {
		*t = tmp;
		return 0;
	} else
		return EINVAL;
}
#endif /* !HAVE_KRB5_STRING_TO_DELTAT */
