#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#include <krb5.h>
#include "pam_krb5.h"

static int seeded = 0;

const char *
compat_princ_component(krb5_context context, krb5_principal princ, int n)
{
    return krb5_princ_component(context, princ, n)->data;
}

int
compat_is_new_password_prompt(krb5_prompt_type *pt, krb5_prompt *prompts,
    int i)
{
	return (pt != NULL && pt[i] == KRB5_PROMPT_TYPE_NEW_PASSWORD);
}

krb5_error_code
krb5_cc_copy_cache(krb5_context context, krb5_ccache in, krb5_ccache out)
{
	return krb5_cc_copy_creds(context, in, out);
}

krb5_error_code
compat_new_memory_cache(krb5_context context, krb5_ccache *ccache)
{
	return krb5_cc_resolve(context, "MEMORY:", ccache);
}

/* MIT's krb5_fcc_gen_new uses mktemp, so we want to avoid it.
 */
extern krb5_cc_ops krb5_fcc_ops;
krb5_error_code
compat_new_file_cache(krb5_context context, krb5_ccache *ccache)
{
	char	fname[] = "/tmp/krb5cc_XXXXXXXX";
	int	fd;

	if (!seeded++) {
#ifdef HAVE_SRANDOMDEV
		srandomdev();
#elif HAVE_RANDOM
		srandom((unsigned long)time(NULL));
#else
		srand((unsigned)time(NULL));
#endif
	}

	fd = mkstemp(fname);
	if (fd < 0)
		return errno;
	close(fd);
	return krb5_cc_resolve(context, fname, ccache);
}
